【LeetCode】第1题,枚举法、HashMap两种解法代码逐行解析


题目:

给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。

你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。

你可以按任意顺序返回答案。

示例 1:

输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1]

示例 2:

输入:nums = [3,2,4], target = 6
输出:[1,2]

示例 3:

输入:nums = [3,3], target = 6
输出:[0,1]

提示:

  • 2 <= nums.length <= 104

  • -109 <= nums[i] <= 109

  • -109 <= target <= 109

  • 只会存在一个有效答案

**进阶:**你可以想出一个时间复杂度小于 O(n2) 的算法吗?


解决方案

方法一:枚举遍历法

package TwoSumSolution;

public class Solution01 {

    public int[] twoSum(int[] nums, int target) {
        int n = nums.length;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (nums[i] + nums[j] == target) {
                    return new int[]{i, j};
                }
            }
        }
        return new int[0];
    }
}

代码解析:

package TwoSumSolution; // 声明这个类所在的包名为TwoSumSolution  
  
public class Solution01 { // 定义一个公开的类Solution01  
  
    // 定义一个方法twoSum,它接收一个整数数组nums和一个整数target作为参数,返回一个整数数组  
    public int[] twoSum(int[] nums, int target) {  
        int n = nums.length; // 获取数组nums的长度,并将其存储在变量n中  
          
        // 使用两层嵌套循环遍历数组nums  
        for (int i = 0; i < n; ++i) { // 外层循环,从数组的第一个元素开始遍历  
            for (int j = i + 1; j < n; ++j) { // 内层循环,从当前外层循环索引i的下一个位置开始遍历  
                // 判断当前外层循环的索引i和内层循环的索引j对应的两个元素之和是否等于目标值target  
                if (nums[i] + nums[j] == target) {  
                    // 如果等于,则创建一个新的整数数组,包含这两个索引i和j,并返回这个数组  
                    return new int[]{i, j};  
                }  
            }  
        }  
          
        // 如果遍历完整个数组都没有找到满足条件的两个整数,则返回一个空的整数数组  
        return new int[0];  
    }  
}

方法二:Hash表

package TwoSumSolution;
import java.util.HashMap;
import java.util.Map;
/*
方法二:哈希表解决
 */
public class Solution02 {
    public int[] twoSum(int[] nums, int target) {
        Map<Integer, Integer> hashTable = new HashMap<Integer, Integer>();
        for (int i = 0; i < nums.length; ++i) {
            if (hashTable.containsKey(target - nums[i])) {
                return new int[]{hashTable.get(target - nums[i]), i};
            }
            hashTable.put(nums[i], i);
        }
        return new int[0];
    }
}

代码解析:

package TwoSumSolution; // 声明一个包名为TwoSumSolution,用于组织类  
  
import java.util.HashMap; // 导入HashMap类,用于存储键值对  
import java.util.Map; // 导入Map接口,HashMap实现了这个接口  
  
/*  
方法二:哈希表解决  
这是一个解决“两数之和”问题的算法,通过使用哈希表来存储遍历过的数字及其索引,  
以加快查找速度,达到O(n)的时间复杂度。  
*/  
public class Solution02 {  
    // 定义一个方法,用于找到数组中两个数,使得它们的和等于给定的目标值target  
    // 参数nums是整数数组,target是目标和  
    // 返回值是一个整数数组,包含两个索引,表示找到的两个数的位置  
    public int[] twoSum(int[] nums, int target) {  
        // 创建一个HashMap实例,用于存储遍历过的数字及其索引  
        Map<Integer, Integer> hashTable = new HashMap<Integer, Integer>();  
          
        // 遍历数组nums  
        for (int i = 0; i < nums.length; ++i) {  
            // 检查当前遍历到的数字(target - nums[i])是否已经在哈希表中  
            // 如果在,说明找到了两个数,它们的和等于target  
            if (hashTable.containsKey(target - nums[i])) {  
                // 返回一个包含两个索引的数组,分别是哈希表中存储的索引和当前遍历到的索引  
                return new int[]{hashTable.get(target - nums[i]), i};  
            }  
            // 如果没有找到,则将当前数字及其索引存入哈希表,以便后续查找  
            hashTable.put(nums[i], i);  
        }  
          
        // 如果遍历完数组都没有找到满足条件的两个数,则返回一个空的整数数组  
        return new int[0];  
    }  
}

方法概述

  • HashMap<Integer, Integer>: 是Java中的一个类,实现了Map接口。它存储键值对,其中键和值都可以是任意类型的对象。在这个例子中,键是数组中的数字,值是该数字在数组中的索引。HashMap通过哈希表实现,因此查找操作的时间复杂度通常是O(1)。

  • containsKey(Object key): 是HashMap类的一个方法,用于检查HashMap中是否包含指定的键。如果包含,则返回true;否则返回false。

  • get(Object key): 是HashMap类的另一个方法,用于获取与指定键相关联的值。如果HashMap包含该键的映射,则返回对应的值;否则返回null。

  • put(K key, V value): 是HashMap类的一个方法,用于将指定的键与值存入HashMap中。如果HashMap之前包含该键的映射,则替换旧值。

  • 5
    点赞
  • 9
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
### 回答1: class Solution: def twoSum(self, nums: List[int], target: int) -> List[int]: for i in range(len(nums)): for j in range(i+1, len(nums)): if nums[i] + nums[j] == target: return [i, j] ### 回答2: leetcode 第1是"两数之和",目要求在给定的整数数组中找到两个数,使它们的和等于一个目标值,并返回这两个数的索引。下面是使用哈希表解决这个问的Python代码: ```python def twoSum(nums, target): # 创建一个空的哈希表 hashmap = {} # 遍历整个数组 for i, num in enumerate(nums): # 计算当前数字与目标值的差值 complement = target - num # 如果差值存在于哈希表中,则返回差值的索引和当前数字的索引 if complement in hashmap: return [hashmap[complement], i] # 将当前数字添加到哈希表中,索引作为键,数字作为值 hashmap[num] = i # 如果未找到符合条件的数字,则返回空列表 return [] ``` 这个算法的基本思想是,在遍历整个数组的过程中,先计算当前数字与目标值的差值,然后将差值与当前数字的索引存储在哈希表中。接下来,在遍历数组的过程中,如果差值存在于哈希表中,则说明找到了两个数的和等于目标值,直接返回这两个数的索引。如果遍历完成后仍未找到符合条件的数对,则返回空列表。这个算法的时间复杂度为 O(n),其中 n 为数组的长度。 ### 回答3: 目描述:两数之和 给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出和为目标值的那两个整数,并返回它们的数组下标。 示例: 输入:nums = [2,7,11,15], target = 9 输出:[0,1] 解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。 思路:使用字典存储数组中的数字及其对应的下标,然后遍历数组找到与目标值的差值,如果差值也在字典中,说明找到了答案。 具体实现如下: ```python def twoSum(nums, target): # 创建一个字典存储数组中的数字及其对应的下标 num_dict = {} for i in range(len(nums)): # 计算与目标值的差值 complement = target - nums[i] # 如果差值也在字典中,说明找到了答案 if complement in num_dict: return [num_dict[complement], i] # 将数字及其对应的下标存入字典中 num_dict[nums[i]] = i return [] nums = [2, 7, 11, 15] target = 9 result = twoSum(nums, target) print(result) # 输出 [0, 1] ``` 以上就是 LeetCode 第1的 Python 解代码
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值